entry:
    LDA #$5C
    TAX
    JSR popcount
    BRK

; Count 1 bits in X register.
; Result returned in accumulator.
popcount:
    TXA           ; copy arg to A
    PHA           ; push arg on stack temporarily
    CLC           ; clear carry flag
    LDA #$08      ; prepare to loop 8 times
    TAY           ; Y register is the loop counter
    LDA #$00      ; initial count is 0
    TAX           ; X will store the count
    PLA           ; restore saved arg to A

loop:
    LSR A         ; shift into C flag
    BCC update    ; if carry is clear, don't increment X
    INX           ; count a 1 bit

update:
    DEY           ; decrement loop counter
    BEQ end       ; done if loop counter is 0
    JMP loop      ; otherwise continue loop

end:
    TXA           ; copy final X value to Accum
    RTS
